/*
Sirius Tuner Widget
by Tanner Jepsen (neoscrib@gmail.com)

Not affiliated with or supported by Sirius Radio Online
Copyright (c) 2006 Tanner Jepsen.  All rights reserved.
*/

var lineup_url = "http://www.sirius.com/sirius/mediaplayer/player/common/lineup/";
var channels = new Array();

SiriusTuner.prototype.getMainCategories = function() { // return type: array()
	var ret = new Array();
	var url = new URL();
	
	url.setRequestHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0)");
	url.setRequestHeader("Cookie", this.cookies);
	url.fetch("http://www.sirius.com/sirius/mediaplayer/player/common/lineup/category.jsp?");
	if (url.response < 400) {
		resp = url.responseData.replace(/\x26(?!amp;)/g, "&amp;");
		var doc = XMLDOM.parse(resp);
		var a = doc.getElementsByName("a");
		log("Found " + a.length + " main categories");
		for (var j = 0; j < a.length; j++) {
			var cat = trim(a.item(j).getAttribute("href").split("(")[1].split(",")[0].replace(/\x27/g, ""));
			log("Main Category " + j + ": " + cat);
			ret[ret.length] = cat
		}
		return ret;
	} else {
		return null;
	}
}

SiriusTuner.prototype.getCategories = function() { //return type: SiriusCategory[]
	var mCats = this.getMainCategories(); //new Array("music", "cathowardstern", "cattalk", "catcomedy", "catfamilykid", "catsports", "catentertainment");
	var ret = new Array();
	var resp = "";
	var url = new URL();
	
	url.setRequestHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0)");
	url.setRequestHeader("Cookie", this.cookies);

	for (var i = 0; i < mCats.length; i++)
	{
		log("Retrieving Sirius categories for '" + mCats[i] + "'");
		url.fetch(lineup_url + "genre.jsp?category=" + mCats[i]);
		
		log("Response: " + url.response);
		if (url.response < 400) {
			resp = url.responseData.replace(/\x26(?!amp;)/g, "&amp;");
			var doc = XMLDOM.parse(resp);
			var a = doc.getElementsByName("a");
			log("Found " + a.length + " categories");
			for (var j = 0; j < a.length; j++) {
				var cat = trim(a.item(j).getAttribute("href").split(",")[1].replace(/\x27/g, ""));
				var name = a.item(j).firstChild.data;
				ret[ret.length] = new SiriusCategory(cat, name, mCats[i]);
				log("Category " + j + ": " + cat + " (" + name + ")");
			}
		}
	}
	categories = ret;
	return ret;
}

SiriusTuner.prototype.getStations = function(cats) { //cats = SiriusCategory[]
	var resp;
	var exists = new Array();
	var ret = new Array();
	var url = new URL();
	
	url.setRequestHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0)");
	url.setRequestHeader("Cookie", this.cookies);
	
	for (var i = 0; i < cats.length; i++)	{
		log("Retrieving Channels for Category: " + cats[i].cat + ", Genre: " + cats[i].id);
		url.fetch(lineup_url + "channel.jsp?category=" + cats[i].cat + "&genre=" + cats[i].id);
		log("Response: " + url.response);

		if (url.response < 400) {
			//log("Last Modified: " + url.getResponseHeaders("Last-Modofied"));
			resp = url.responseData.replace(/\x26(?!amp;)/g, "&amp;");
		
			var doc = XMLDOM.parse(resp);
			var a = doc.getElementsByName("a");
			log("Found " + (a.length / 3) + " Channels");

			for (var j = 0; j < a.length; j += 3) {
				var statid = trim(a.item(j).getAttribute("href").split(",")[2].replace(/\x27/g, ""));
				var statnum = a.item(j).firstChild.data.split(" ")[0];
				var statname = a.item(j+1).firstChild.data;
				var statdesc = a.item(j+2).firstChild.data;
			
				if (!exists[statnum]) {
					ret[ret.length] =  new SiriusChannel(cats[i], statnum, statname, statid, statdesc);
					channels[channels.length] = statnum - 0;
					log("Channel " + ret.length + ": " + statnum + " (Name: " + statname + ", ID: " + statid + ")");
					exists[statnum] = true;
				}
			}
		}
	}
	
	channels.sort(sortNumerically);

	log("Total Channels: " + ret.length);
	return ret;
}

function SiriusCategory(id, name, cat) {
	this.id = id;
	this.name = name;
	this.cat = cat;
}

function SiriusChannel(category, num, name, id, desc) {
	this.category = category;
	this.num = num;
	this.name = name;
	this.id = id;
	this.desc = desc.replace("&", "&&&");
	this.url = "";

	this.previousChannel;
	this.nextChannel;

	this.currentArtist;
	this.currentTitle;
}

SiriusChannel.prototype.play = function(cookies) {
	if (this.isBlocked()) {
		if (!(prompt("Parental Controls", "Enter Password:", true) == preferences.parentalPassword.value)) {
			SiriusTuner.instance.stop();
			log("Channel " + this.num + " blocked by parental controls!");
			alert(this.name + " has been blocked by parental controls.");
			return; //else continue;
		}
	}
	
	log("Retrieving channel stream URL");
	Player.instance.mainScreen.setStatusDisplay("Retrieving channel stream " + this.name + "...");
	var playerURL = new URL();
	var activity = (preferences.hiBitRate.value == 1 && SiriusTuner.instance.canUseHighBitRate) ? "selectBitrate&bitrate=high" : "selectStream";
	playerURL.location = servlet_url + "?activity=" + activity + "&stream=" + this.id + "&genre=" + this.category.id + "&category=" + this.category.cat + "&token=" + SiriusTuner.instance.token;
	playerURL.setRequestHeader("Cookie", cookies);
	playerURL.fetchAsync(playChannel);
}

SiriusChannel.prototype.resetData = function() {
	this.currentArtist = null;
	this.currentTitle = null;
	if (this.nextChannel.num > this.num) { this.nextChannel.resetData(); }
}

SiriusChannel.prototype.nextChannelByNum = function() {		
	for (var i = 0; i < channels.length; i++) {
		if (channels[i] == (this.num - 0)) {
			if (i == channels.length - 1) {
				return siriusTuner.channels[channels[0]];
			} else {
				return siriusTuner.channels[channels[i+1]];
			}
		}
	}
}

SiriusChannel.prototype.previousChannelByNum = function() {
	for (var i = 0; i < channels.length; i++) {
		if (channels[i] == (this.num - 0)) {
			if (i == 0) {
				return siriusTuner.channels[channels[channels.length-1]];
			} else {
				return siriusTuner.channels[channels[i-1]];
			}
		}
	}
}

SiriusChannel.prototype.isBlocked = function() {
	if (preferences.enableParentalControls.value == 0) return false;
	var blockedChannels = preferences.blockedChannels.value.split(",");
	for (var i = 0; i < blockedChannels.length; i++) {
		if ((blockedChannels[i] * 1) == this.num) {
			return true;
		}
	}
	return false;
}

function sortNumerically(a, b) {
	return a - b;
}