function regGetValue(key, returnType) {	
	if (key.lastIndexOf("\\") == key.length - 1) {
		value = "<NO NAME>";
		key = key.substring(0, key.length - 1);
	} else {
		var a = key.split("\\");
		value = a.pop();
		key = a.join("\\\\");
	}
	
	var result = runCommand("reg query \"" + key + "\"");
	var lines = result.split(String.fromCharCode(10));

	for (var i = 0; i < lines.length; i++) {
		if (lines[i].indexOf("    ") == 0) {
			var line = trim(lines[i]).split(String.fromCharCode(9));
			if (line[0] == value) {
				if (returnType)
					return line[1];
				if (trim(line[1]) == "REG_MULTI_SZ")
					line[2] = line[2].replace(/[\\0]+$/, "");
					return line[2].split("\\0");
				return line[2];
			}
		}
	}
	return null;
}

function regGetValueType(key) {
	return regGetValue(key, true);
}

function regSetValue(key, data, type) {
	if (key.lastIndexOf("\\") == key.length - 1) {
		value = null;
		key = key.substring(0, key.length - 1);
	} else {
		var a = key.split("\\");
		value = a.pop();;
		key = a.join("\\\\");
	}
	
	value = (value == null ? "/ve" : "/v " + value);
	type = (type == null ? "/t REG_SZ" : "/t " + type);
	data = data.split("\"").join("\\\\\"");
	data = (type == "/t REG_MULTI_SZ" ? "/d \"" + data.join("\\0") + "\"": "/d \"" + data + "\"");
	var cmd = "reg add \"" + key + "\" " + value + " " + type + " " + data + " /f";
	var result = runCommand(cmd);
	return result.indexOf("The operation completed successfully") > -1;
}

function regValueExists(key) {
	return regGetValue(key) != null;
}

function regKeyExists(key) {
	key = ((key.lastIndexOf("\\") == key.length - 1) ? key.substring(0, key.length - 1) : key).split("\\").join("\\\\");
	var result = runCommand("reg query \"" + key + "\"");
	return result.indexOf("The system was unable to find the specified registry key") == -1;	
}