var skinFiles = new Array("0_button.png", "0_button_inset.png", "1_button.png", "1_button_inset.png", "2_button.png", "2_button_inset.png",
	"3_button.png", "3_button_inset.png", "4_button.png", "4_button_inset.png", "5_button.png", "5_button_inset.png",
	"6_button.png", "6_button_inset.png", "7_button.png", "7_button_inset.png", "8_button.png", "8_button_inset.png",
	"9_button.png", "9_button_inset.png", "base.png", "chdown_button.png", "chdown_button_inset.png",
	"chup_button.png", "chup_button_inset.png", "guide_button.png", "guide_button_inset.png", "logo.png",
	"mute_button.png", "mute_button_inset.png", "play_button.png", "play_button_inset.png", "power_button.png",
	"power_button_inset.png", "preset_button.png", "preset_button_inset.png", "screen.png", "scroll_thumb.png",
	"scroll_track.png", "signal_tick_1.png", "signal_tick_2.png", "signal_tick_3.png", "stop_button.png",
	"stop_button_inset.png", "volume_down.png", "volume_down_inset.png", "volume_tick.png", "volume_up.png", "volume_up_inset.png", "info.xml");
	
function findFile(directoryPath, fileName) {
	var files = filesystem.getDirectoryContents(directoryPath, true);
	for (var i = 0; i < files.length; i++) {
		if (getFilename(files[i]) == fileName) {
			return directoryPath + "/" + files[i];
		}
	}
	return null;
}
	
function getSWSSkinName(fullpath) { //extracts info.xml file from sws file and gets the skin name
	var wdf = system.widgetDataFolder;
	var filename = getFilename(fullpath)
	var skinName = getPathNoExtension(filename);
	var name = null;
	
	if (getFileExtension(filename) == ".sws") {
		var infoPathFolder = wdf + "/tmp/" + skinName;
		md(infoPathFolder);
	
		filesystem.unzip(fullpath, infoPathFolder);
		var infoPath = findFile(infoPathFolder, "info.xml");
		
		if (infoPath != null && filesystem.itemExists(infoPath)) {
			var infoText = filesystem.readFile(infoPath);
			var doc = XMLDOM.parse(infoText);
			name = doc.evaluate("string(siriusTunerSkin/name)");
			deleteIfExists(infoPath);
		}
		return name;
	}	
}

function skinMinWidgetVersion(skinName) {
	var wdf = system.widgetDataFolder;
	if (skinName == null)
		skinName = preferences.currentSkin.value;
	var skinPath = wdf + "/skins";
	var infoPath = skinPath + "/" + skinName + "/info.xml";
	var ver = null;
	
	if (filesystem.itemExists(infoPath)) {
		var infoText = filesystem.readFile(infoPath);
		var doc = XMLDOM.parse(infoText);
		ver = doc.evaluate("string(siriusTunerSkin/minVersion)");
	}
	return ver;
}
	
function setFileAssociations() {
	var iconPath = widget.extractFile("resources/images/dog.ico");
	var assocPath = widget.extractFile("resources/programs/assoc.js");
	iconPath = iconPath.split("/").join("\\");
	assocPath = assocPath.split("/").join("\\");
	
	try {
		if (system.platform == "windows") {
			if (regGetValue("HKEY_CLASSES_ROOT\\.sws\\") != "SiriusWidgetSkin") {
				var ret = true;
			  ret &= regSetValue("HKEY_CLASSES_ROOT\\.sws\\", "SiriusWidgetSkin");
		  	ret &= regSetValue("HKEY_CLASSES_ROOT\\SiriusWidgetSkin\\", "Sirius Widget Skin");
		  	ret &= regSetValue("HKEY_CLASSES_ROOT\\SiriusWidgetSkin\\DefaultIcon\\", iconPath);
		  	ret &= regSetValue("HKEY_CLASSES_ROOT\\SiriusWidgetSkin\\shell\\open\\command\\", "%SystemRoot%\\System32\\WScript.exe \"" + assocPath + "\" \"%1\"", "REG_EXPAND_SZ");
		  	if (!ret) log("setFileAssociations Failed due to: Unknown (1)");
	  	}
  	} else {
  		throw new Error("setFileAssociations(SkinFunctions.js): Not a Windows platform.");
  	}
	} catch (e) {
		log("setFileAssociations(SkinFunctions.js): Failed due to " + e);
	}
}

function copyDefaultSkin() {
	var wdf = system.widgetDataFolder;
	var skinPath = wdf + "/skins";
	var defSkinPath = skinPath + "/" + preferences.currentSkin.defaultValue;
	var extPath = "";
	
	if (filesystem.itemExists(defSkinPath) && (!filesystem.itemExists(defSkinPath + "/info.xml")))
		deleteDefaultSkin();
		
	var currentVersion = skinMinWidgetVersion(preferences.currentSkin.defaultValue);
	if (currentVersion != null && currentVersion != widget.version)
		deleteDefaultSkin();
		
	if (!filesystem.itemExists(defSkinPath)) {
		md(skinPath);
		md(defSkinPath);

		for (var i = 0; i < skinFiles.length; i++) {
			extPath = widget.extractFile("resources/images/" + skinFiles[i]);
			filesystem.move(extPath, defSkinPath);
		}
	}
}

function deleteDefaultSkin() {
	var wdf = system.widgetDataFolder;
	var skinPath = wdf + "/skins";
	var defSkinPath = skinPath + "/" + preferences.currentSkin.defaultValue;
	deleteIfExists(defSkinPath, true);
}

function loadSkin() {
	var wdf = system.widgetDataFolder;
	var skinPath = wdf + "/skins";
	var currentSkin = skinPath + "/" + preferences.currentSkin.value;
	
	if (filesystem.itemExists(currentSkin)) {
		var skinMinVer = skinMinWidgetVersion();
		if ((skinMinVer == null) || (compareVersionNum(widget.version, skinMinVer) < 0)) {
			if (alert("The currently selected skin is not supported by this version of the Sirius Tuner.\nDo you want to go to neoscrib.com to check for an update?", "Yes", "No") == 1) {
				openURL("http://www.neoscrib.com/index.php?page=siriusskins");
			}
			preferences.currentSkin.value = preferences.currentSkin.defaultValue;
			savePreferences();
			currentSkin = skinPath + "/" + preferences.currentSkin.value;
		}


		for (var num = 0; num <= 9; num++) {
			Player.instance.numberButtons[num].src = Player.instance.mainScreen.getImage(num + "_button.png");
		}

		base.src = Player.instance.mainScreen.getImage("base.png");
		Player.instance.downButton.src = Player.instance.mainScreen.getImage("chdown_button.png");
		Player.instance.upButton.src = Player.instance.mainScreen.getImage("chup_button.png");
		Player.instance.guideButton.src = Player.instance.mainScreen.getImage("guide_button.png");
		Player.instance.mainScreen.logo.src = Player.instance.mainScreen.getImage("logo.png");
		Player.instance.muteButton.src = Player.instance.mainScreen.getImage("mute_button.png");
		Player.instance.playButton.src = Player.instance.mainScreen.getImage("play_button.png");
		Player.instance.powerButton.src = Player.instance.mainScreen.getImage("power_button.png");
		Player.instance.presetBankButton.src = Player.instance.mainScreen.getImage("preset_button.png");
		screen.src = Player.instance.mainScreen.getImage("screen.png");
		Player.instance.mainScreen.signalStrength[0].src = Player.instance.mainScreen.getImage("signal_tick_1.png");
		Player.instance.mainScreen.signalStrength[1].src = Player.instance.mainScreen.getImage("signal_tick_2.png");
		Player.instance.mainScreen.signalStrength[2].src = Player.instance.mainScreen.getImage("signal_tick_3.png");
		Player.instance.stopButton.src = Player.instance.mainScreen.getImage("stop_button.png");
		Player.instance.volumeDownButton.src = Player.instance.mainScreen.getImage("volume_down.png");
		Player.instance.volumeUpButton.src = Player.instance.mainScreen.getImage("volume_up.png");

		if (preferences.currentSkin.value == preferences.currentSkin.defaultValue) {
			screen.hOffset = 19;
			screen.vOffset = 17;
			Player.instance.activeScreen.frame.hOffset = 19;
			Player.instance.activeScreen.frame.vOffset = 17;
			if (Player.instance.activeScreen.frame.vScrollBar != null) {
				Player.instance.activeScreen.frame.vScrollBar.hOffset = 163;
				Player.instance.activeScreen.frame.vScrollBar.vOffset = 10;
			}
		} else {
			screen.hOffset = 22;
			screen.vOffset = 20;
			Player.instance.activeScreen.frame.hOffset = 22;
			Player.instance.activeScreen.frame.vOffset = 20;
			if (Player.instance.activeScreen.frame.vScrollBar != null) {
				Player.instance.activeScreen.frame.vScrollBar.hOffset = 166;
				Player.instance.activeScreen.frame.vScrollBar.vOffset = 13;
			}
		}
		Player.instance.activeScreen.updateColors();
	}
}

function onDragDrop() {
	if (system.event.data[0] == "filenames") {
		var fullpath = system.event.data[1];
		dropSkin(fullpath);
	}
}

function dropSkin(fullpath) {
	var wdf = system.widgetDataFolder;
	var filename = getFilename(fullpath)
	var path = getPath(fullpath);
	var skinName = getSWSSkinName(fullpath);
	var skinPath = wdf + "/skins/" + skinName;
	var currentSkin = skinPath + "/" + skinName;
	
	if (getFileExtension(filename) == ".sws") {
		var tmpPath = wdf + "/tmp/" + skinName;
		md(tmpPath);
		md(skinPath);
		filesystem.unzip(fullpath, tmpPath);
		tmpPath = getPath(findFile(tmpPath, "info.xml"));
		var files = filesystem.getDirectoryContents(tmpPath, true);
		for (var i = 0; i < files.length; i++) {
			filesystem.move(tmpPath + "/" + files[i], skinPath);
		}

		preferences.currentSkin.value = skinName;
		loadSkin();

		if (preferences.promptSkinFileAction.value == 1) {
			var resp = alert("The skin \"" + skinName + "\" has been installed. Do you want to delete the sws file?", "Yes", "No", "No, don't ask me again");
			if (resp == 1) filesystem.moveToTrash(fullpath);
			if (resp == 3) preferences.promptSkinFileAction.value = 0;
			savePreferences();
		}
	}
}

function chooseInstallSkin() {
	var path = chooseFile(".sws");
	if (path != null)
		dropSkin(path);
}

function getSkinNames() {
	var wdf = system.widgetDataFolder;
	var skinPath = wdf + "/skins";
	var folders = filesystem.getDirectoryContents(skinPath, false);
	var ret = new Array();
	var count = 0;
	
	for (var i = 0; i < folders.length; i++) {
		var infoPath = skinPath + "/" + folders[i] + "/info.xml";
		if (filesystem.itemExists(infoPath)) {
			var infoText = filesystem.readFile(infoPath);
			var doc = XMLDOM.parse(infoText);
			if (compareVersionNum(widget.version, doc.evaluate("string(siriusTunerSkin/minVersion)")) >= 0) {
				ret[count] = doc.evaluate("string(siriusTunerSkin/name)");
				count++;
			}
		}
	}
	return ret;
}

function selectSkin() {
	var skins = getSkinNames();

	var formFields = new Array();
	formFields[0] = new FormField();
	formFields[0].name = "skin";
	formFields[0].title = "Skin:";
	formFields[0].type = "popup";
	formFields[0].option = new Array();

	if (skins.length > 0) {		
		var count = 0;
		for (i = 0; i <= skins.length - 1; i++) {
			formFields[0].option[count] = skins[i]
			count++;
		}
		formFields[0].value = preferences.currentSkin.value;
	}

	if (system.platform == "windows")
		formFields[0].option[count] = "Browse (Install new skin)...";

	var formResults = form(formFields, "Select a Skin", "OK");

	if (formResults != null) {
		if (formResults[0] == "Browse (Install new skin)...") {
			chooseInstallSkin();
		} else {
			preferences.currentSkin.value = formResults[0];
			loadSkin();
		}
	}
}

function deleteIfExists(str) {
	if (filesystem.itemExists(str)) {
		filesystem.remove(str);
	}
}

function md(str) {
	var dirs = new Array(str);
	while (dirs[dirs.length-1] != getRoot(str)) {
		dirs[dirs.length] = getPath(dirs[dirs.length-1]);
	}
	
	for (var i = dirs.length - 1; i >= 0; i--) {
		if (!filesystem.itemExists(dirs[i])) {
			filesystem.createDirectory(dirs[i]);
			while (!filesystem.itemExists(dirs[i])) { }
		}
	}
}

function getRoot(str) {
	str = str.replace(/\\/g, "/")
	if (str.indexOf("/") > -1) {
		var strReturn = str.substr(0, str.indexOf("/"));
		if (strReturn.substr(1) == ':') strReturn += '/';
		return strReturn;		
	} else {
		return str;
	}
}

function getPath(str) {
	if (str == null) return null;
	str = str.replace(/\\/g, "/");
	strReturn = str.substr(0, str.lastIndexOf("/"));
	if (strReturn.substr(1) == ":") strReturn += "/";
	return strReturn;
}

function getPathNoExtension(str) {
	return str.substr(0, str.length - getFileExtension(str).length);
}

function getFilename(str) {
	return str.substr(Math.max(str.lastIndexOf('/'), str.lastIndexOf('\\')) + 1);
}

function getFileExtension(str) {
	var strFilename = getFilename(str);
	if (strFilename.indexOf('.') > -1) {
		return strFilename.substr(strFilename.lastIndexOf('.'));
	} else {
		return '';
	}
}

function takeScreenShot() {
	var oldX = main.hOffset;
	var oldY = main.vOffset;
	main.moveTo(295, 20, 1);
	var strCommand = "./resources/programs/ScreenShooter.exe -r -PNG 295,20,280,140 \"" + system.userDesktopFolder + "/" + preferences.currentSkin.value + ".png\"";
	var result = runCommand(strCommand);
	if (result == "1") {
		log("ScreenShot Saved!");
	} else { log("ScreenShot Failed!"); }
	main.moveTo(oldX, oldY, 1);
}

function pngout(dir) {
	var savings = 0;
	
	if (filesystem.isDirectory(dir)) {
		var files = filesystem.getDirectoryContents(dir, false);
		var maxFilenameLength = 0;
		for (var f in files) {
			if ((getFileExtension(files[f]) == ".png") && (files[f].length > maxFilenameLength))
				maxFilenameLength = files[f].length;
		}
		for (var f in files) {
			if (getFileExtension(files[f]) == ".png") {
				var cmd = "./resources/programs/pngout.exe \"" + dir + "/" + files[f] + "\"";
				var output = runCommand(cmd);
				var inSize = trim(ExtractBetween("Input size:", " bytes", output)) * 1;
				var outSize = trim(ExtractBetween("Output size:", " bytes", output, true)) * 1;
				var p = "  " + files[f];
				for (var i = files[f].length; i < maxFilenameLength + 8; i++) {
					p += " ";
				}
				print(p + "In: " + inSize + "\t\tOut: " + outSize + "\t\tSavings: " + (inSize - outSize));
				savings += (inSize - outSize);
			}
		}
	} else if (filesystem.itemExists(dir)) {
		if (getFileExtension(dir) == ".png") {
			var fileName = getFilename(dir);
			var cmd = "./resources/programs/pngout.exe \"" + dir + "\"";
			var output = runCommand(cmd);
			var inSize = trim(ExtractBetween("Input size:", " bytes", output)) * 1;
			var outSize = trim(ExtractBetween("Output size:", " bytes", output, true)) * 1;
			print("  " + fileName + "\t\tIn: " + inSize + "\t\tOut: " + outSize + "\t\tSavings: " + (inSize - outSize));
			savings += (inSize - outSize);
		}
	}
	print("Total Savings: " + savings + " bytes\n");
	Player.instance.displayMessage(savings + " bytes");
}