/*
Sirius Tuner Widget
by Tanner Jepsen (neoscrib@gmail.com)

Not affiliated with or supported by Sirius Radio Online
Copyright (c) 2006 Tanner Jepsen.  All rights reserved.
*/

/**
 * Version Checker
 */
 
var alertVisible = false;

function VersionChecker(appURL, appName, appCurrentVersion, showNoUpdates) {
	this.appURL = appURL;
	this.appName = appName;
	this.appCurrentVersion = appCurrentVersion;
	this.showNoUpdates = showNoUpdates;
}

/* checkVersion - method to check the version */
function _VersionChecker_checkVersion() {
	// define the parameters...
	var galleryURL = "http://www.neoscrib.com/neoscrib/widgetversion.php";
	var regExp = new RegExp(/<div align="right">Version \d+.\d+.\d+ - /);

	var versionURL = new URL();
	versionURL.setRequestHeader("User-Agent", "SiriusTuner/" + this.appCurrentVersion + " (Yahoo! Widget Engine " + konfabulatorVersion() + "; " + system.platform.substring(0, 1).toUpperCase() + system.platform.substring(1) + ")");
	var appLatestVersion = versionURL.fetch(galleryURL);

	if (versionURL.response == "200") {
		var strRegOut = regExp.exec(appLatestVersion);
		regExp = new RegExp(/\d+.\d+.\d+/);
		appLatestVersion = regExp.exec (strRegOut);
		if (appLatestVersion != null && (compareVersionNum(this.appCurrentVersion, appLatestVersion[0]) == -1) && !alertVisible) {
			if ((this.showNoUpdates && preferences.updatesEnableAlert.value == 0) || preferences.updatesEnableAlert.value == 1) {
				var widgetPath = getWidgetPath();
				if (preferences.updatesEnableAutoUpdate.value == 0)
					widgetPath = null;
				
				if (widgetPath == null) {
					var msg = "There is a newer version of " + this.appName + " available: "+ appLatestVersion + "\n\nDo you want to open a browser for downloading?";					
				} else {
					var msg = "There is a newer version of " + this.appName + " available: "+ appLatestVersion + "\n\nDo you want to install this update now?";
				}
				
				alertVisible = true;
				if (this.showNoUpdates || preferences.updatesEnableAlert.value == 0) {
					var getNewVersion = alert(msg, "Yes", "No");
				} else {
					var getNewVersion = alert(msg, "Yes", "No", "No, don't ask me again");
				}
				alertVisible = false;
				
				if (getNewVersion == 1) {
					if (widgetPath != null) {
						var downloadURL = new URL();
						downloadURL.outputFile = system.widgetDataFolder + "/" + getFilename(widgetPath);
						downloadURL.location = "http://www.neoscrib.com/index.php?page=download&pid=70497200&donated=1";
						downloadURL.fetch();
						if (downloadURL.response == 200) {
							filesystem.moveToTrash(widgetPath);
							filesystem.move(downloadURL.outputFile, getPath(widgetPath));
							reloadWidget();
						} else {
							var resp = alert("There was an error downloading the update. Do you want to open a browser for downloading?", "Yes", "No");
							if (resp == 1) openURL("http://www.neoscrib.com/index.php?page=project&id=70497200");
						}
					} else {
						openURL("http://www.neoscrib.com/index.php?page=project&id=70497200");
					}
				}
				if (getNewVersion == 3) preferences.updatesEnableAlert.value = 0;
				
				
			}
		} else {
			if (this.showNoUpdates && !alertVisible) {
				alertVisible = true;
				alert("You are running the latest version of " + this.appName + " : " + this.appCurrentVersion);
				alertVisible = false;
			}
		}
	}
}

/* build the VersionChecker structure and methods to expose */
VersionChecker.prototype = new Object();
VersionChecker.prototype.checkVersion = _VersionChecker_checkVersion;
