/*
Sirius Tuner Widget
by Tanner Jepsen (neoscrib@gmail.com)

Not affiliated with or supported by Sirius Radio Online
Copyright (c) 2006 Tanner Jepsen.  All rights reserved.
*/

include("Screen.js");

/**
 * Volume screen, for showing the volume level in tv-style ticks whenever
 * the volume level is changed.
 */
function VolumeScreen(vol) {
	// the current volume level
	this.volumeLevel = vol;
	
	// the volume label (above the ticks)
	this.volumeLabel = new Text();
	this.volumeLabel.width = screen.width - 10;
	this.volumeLabel.alignment = "center";
	this.volumeLabel.data = "Volume";
	this.volumeLabel.hOffset = screen.width / 2;
	this.volumeLabel.vOffset = (screen.height / 2) + 6;
	this.addSubView(this.volumeLabel);
	
	// the volume tick images for displaying the volume level
	this.volumeTicks = new Array();
	this.init();
	this.updateColors();
}

VolumeScreen.prototype = new Screen();

VolumeScreen.prototype.init = function() {
	for (var i = 0; i < 20; i++) {
		this.volumeTicks[i] = new Image();
		this.volumeTicks[i].src = this.getImage("volume_tick.png");
		this.volumeTicks[i].width = 6;
		this.volumeTicks[i].height = 13;
		this.volumeTicks[i].window = main;
		this.volumeTicks[i].hOffset = 5 + (i * this.volumeTicks[i].width) + i;
		this.volumeTicks[i].vOffset = 50;
		this.addSubView(this.volumeTicks[i]);
	}
	this.updateVolume(this.volumeLevel);
}


/**
 * Updates the volume display
 */
VolumeScreen.prototype.updateVolume = function(vol) {
	this.volumeLevel = vol
	var ticks = Math.round(this.volumeLevel / 5);
	for (var i = 0; i < 20; i++) {
		if (i < ticks) {
			this.volumeTicks[i].opacity = 255;
		} else {
			this.volumeTicks[i].opacity = 50;
		}
	}
}

VolumeScreen.prototype.updateColors = function() {
	this.applyShadow(this.volumeLabel);
	this.applyFont(this.volumeLabel);
	this.volumeLabel.color = this.skinColors("darkColor");
	for (var i = 0; i < this.volumeTicks.length; i++) {
		this.volumeTicks[i].src = this.getImage("volume_tick.png");
	}
}