function onUnload() {
	if (system.platform != "windows")
		log("Sending Stop Command: " + appleScript("tell application \"Windows Media Player\" to quit\n"));

	deleteIfExists(system.widgetDataFolder + "/tmp");
}

function onWillChangePreferences() {
	preferences.enableParentalControls1.value = preferences.enableParentalControls.value;
	preferences.parentalPassword1.value = preferences.parentalPassword.value;
	preferences.blockedChannels1.value = preferences.blockedChannels.value;
}

function onPreferencesChanged() {
	if (player.siriusTuner.user != preferences.user.value || player.siriusTuner.password != preferences.password.value) {
		preferences.token.value = null;
		player.siriusTuner.user = preferences.user.value;
		player.siriusTuner.password = preferences.password.value;
		mnuLoginClicked();
	}

	// start alarm timer
	this.alarm.ticking = (preferences.enableAlarm.value == 1);
	Player.instance.alarmSnoozeTimer.interval = preferences.snoozeTimeout.value;
	Player.instance.mainScreen.alarmIcon.opacity = 40 + (preferences.enableAlarm.value * 215);
	
	//start/stop/change interval of update timer
	this.checkForUpdates.interval = (preferences.updatesInterval.value * 3600);
	this.checkForUpdates.ticking = (preferences.updatesEnableAlert.value == 1);
	
	if (preferences.useSiriusBackstageData.value == 1)
		player.siriusTuner.loadWhatsOn();
	else
		player.siriusTuner.firstChannel.resetData(); player.updateScreen();
		
	player.updateNumberButtonTooltips();
	
	preferences.alertItem1.value = trim(preferences.alertItem1.value);
	preferences.alertItem2.value = trim(preferences.alertItem2.value);
	preferences.alertItem3.value = trim(preferences.alertItem3.value);
	preferences.alertItem4.value = trim(preferences.alertItem4.value);
	preferences.alertItem5.value = trim(preferences.alertItem5.value);
	
	if (player.activeScreen instanceof ChannelGuideScreen)
		player.activeScreen.updateChannelData();

	player.refreshWhatsOnTimer.interval = preferences.refreshWhatsOnInterval.value;
	player.refreshWhatsOnTimer.ticking = (preferences.useSiriusBackstageData.value == 1);
	player.initHotkeys();
	
	if (preferences.alarmChannelSelect.value == 1) {
		preferences.alarmChannelSelect.value = 0;
		setAlarmClockChannelPref();
	}
	
	if (preferences.whatsOnSelectURL.value == 1) {
		preferences.whatsOnSelectURL.value = 0;
		setWhatsOnDataSource();
	}
	
	updateParentalControls();
	
	AnimToggleAlbumArtSize();
	
	if ((!SiriusTuner.instance.canUseHighBitRate) && preferences.hiBitRate.value == 1 && (SiriusTuner.instance.isLoggedIn())) {
		var resp = alert("You have selected to use the Premium Service but this service does not appear to be enabled on you Sirius account. Do you want to sign up for this service now?", "Yes", "No");
		if (resp == 1) {
			openURL((isEmailAddress(SiriusTuner.instance.user) ? "http://www.sirius.com/internetradiononsubscriber" : "http://www.sirius.com/internetradiosubscriber"));
		} else {
			preferences.hiBitRate.value = 0;
		}
	}
}

function onKeyDown() {
	var player = Player.instance;
	var key = system.event.key;
	var keyString = system.event.keyString;

	if (system.event.modifiers != "") return;

	switch (keyString) {
		case "UpArrow": player.upButtonDown(); break;
		case "DownArrow": player.downButtonDown(); break;
		case "LeftArrow": player.stopButtonDown(); break;
		case "RightArrow": player.playButtonDown(); break;
		case "Return": if (player.activeScreen instanceof ChannelGuideScreen) player.guideButtonDown(); break;
		default:
			if (keyString.indexOf("x") == 1) {
				if (key == "g" && player.activeScreen instanceof MainScreen) {
					player.guideButtonDown();
				} else if (key >= 0 && key <= 9) {
					player.presetButtonPressed(key);
				} else if (key == "+" || key == "=") {
					player.volumeUpButtonDown();
				} else if (key == "-") {
					player.volumeDownButtonDown();
				} else if (key == "m") {
					player.muteButtonDown();
				} else if (key == "p") {
					player.presetBankButtonDown();
				} else if (key == "x") {
					player.powerButtonDown();
				}
			}
	}
}

function onKeyUp() {
	var key = system.event.key;
	var keyString = system.event.keyString;

	if (system.event.modifiers != "") return;

	switch (keyString) {
		case "UpArrow": player.upButtonUp(); break;
		case "DownArrow": player.downButtonUp(); break;
		case "LeftArrow": player.stopButtonUp(); break;
		case "RightArrow": player.playButtonUp(); break;
		case "Return": if (player.activeScreen instanceof ChannelGuideScreen) player.guideButtonUp(); break;
		default:
			if (keyString.indexOf("x") == 1) { 
				if (key == "g" && player.activeScreen instanceof MainScreen) {
					player.guideButtonUp();
				} else if (key >= 0 && key <= 9) {
					player.presetButtonReleased(key);
				} else if (key == "+") {
					player.volumeUpButtonUp();
				} else if (key == "-") {
					player.volumeDownButtonUp();
				} else if (key == "m") {
					player.muteButtonUp();
				} else if (key == "p") {
					player.presetBankButtonUp();
				} else if (key == "a" || key == "b" || key == "c" || key == "#") {
					player.switchPresetBank(key);
				} else if (key == "x") {
					player.powerButtonUp();
				}
			}
	}
}

function onContextMenu() {
	var mi = new Array();
	var i = 0;
	
	mi[i] = new MenuItem();
	mi[i].title = "Export Preferences...";
	mi[i].onSelect = "exportPreferences();";
	i++;
	
	mi[i] = new MenuItem();
	mi[i].title = "Import Preferences...";
	mi[i].onSelect = "importPreferences();";
	i++;
	
	mi[i] = new MenuItem();
	mi[i].title = "-";
	i++;	

	mi[i] = new MenuItem();
	mi[i].enabled = (player.siriusTuner.currentChannel != null && player.siriusTuner.currentChannel.currentArtist != null && trim(player.siriusTuner.currentChannel.currentArtist) != "");
	var currentArtist = "Current Artist";
	if (mi[i].enabled) currentArtist = player.siriusTuner.currentChannel.currentArtist;
	mi[i].title = "Add " + currentArtist + " to Favorites";
	if (player.siriusTuner.currentChannel != null)
		mi[i].onSelect = "mnuAddArtistToAlertClicked(" + player.siriusTuner.currentChannel.num + ");";
	i++;

	mi[i] = new MenuItem();
	mi[i].enabled = (player.siriusTuner.currentChannel != null && player.siriusTuner.currentChannel.currentTitle != null && trim(player.siriusTuner.currentChannel.currentTitle) != "");
	var currentTitle = "Current Track";
	if (mi[i].enabled) currentTitle = player.siriusTuner.currentChannel.currentTitle;
	mi[i].title = "Add " + currentArtist + " - " + currentTitle + " to Favorites";
	if (player.siriusTuner.currentChannel != null)
		mi[i].onSelect = "mnuAddTitleToAlertClicked(" + player.siriusTuner.currentChannel.num + ");";
	i++;

	mi[i] = new MenuItem();
	mi[i].title = "-";
	i++;

	if (!player.siriusTuner.isLoggedIn()) {
		mi[i] = new MenuItem();
		mi[i].title = "Login to SIRIUS Online";
		mi[i].enabled = !player.siriusTuner.isLoggedIn();
		mi[i].onSelect = "mnuLoginClicked();";
		i++;
	}

	mi[i] = new MenuItem();
	mi[i].title = "Check for Update...";
	mi[i].onSelect = "checkForUpdate(true);";
	i++;
	
	mi[i] = new MenuItem();
	mi[i].title = "Go to Widget forums...";
	mi[i].onSelect = "openURL('http://www.siriusbackstage.com/forum/showthread.php?t=76249&page=5000');";
	i++;
	
	mi[i] = new MenuItem();
	mi[i].title = "Submit Feedback...";
	mi[i].onSelect = "openURL('http://www.neoscrib.com/index.php?page=contact');";
	i++;
	
	mi[i] = new MenuItem();
	mi[i].title = "Send a Donation...";
	mi[i].onSelect = "openURL('http://www.neoscrib.com/index.php?page=donate');";
	i++;

	mi[i] = new MenuItem();
	mi[i].title = "View Readme...";
	mi[i].onSelect = "filesystem.open(\"readme.txt\");";
	i++;
	
	mi[i] = new MenuItem();
	mi[i].title = "-";
	i++;

	mi[i] = new MenuItem();
	mi[i].title = "Use Channel Data (What's On)";
	mi[i].checked = (preferences.useSiriusBackstageData.value == 1);
	mi[i].onSelect = "mnuUseSiriusBackstageDataClicked();";
	i++;

	mi[i] = new MenuItem();
	mi[i].title = "Enable Favorites Alerts";
	mi[i].checked = (preferences.alertEnable.value == 1);
	mi[i].onSelect = "mnuUseArtistAlertClicked();";
	i++;

	mi[i] = new MenuItem();
	mi[i].title = "Enable Alarm Clock";
	mi[i].checked = (preferences.enableAlarm.value == 1);
	mi[i].onSelect = "mnuUseAlarmClockClicked();";
	i++;

	mi[i] = new MenuItem();
	mi[i].title = "-";
	i++;

	mi[i] = new MenuItem();
	mi[i].title = "Select a Skin...";
	mi[i].onSelect = "selectSkin();";
	i++;
	
	mi[i] = new MenuItem();
	mi[i].title = "Get More Skins...";
	mi[i].onSelect = "openURL('http://www.neoscrib.com/index.php?page=siriusskins');";
	i++;
	
	mi[i] = new MenuItem();
	mi[i].title = "-";
	i++;
	
	mi[i] = new MenuItem();
	mi[i].title = "Reload Widget";
	mi[i].onSelect = "reloadWidget();";

	main.contextMenuItems = mi;
}

function mnuAddArtistToAlertClicked(ch) {
	var siriusTuner = SiriusTuner.instance;
	if (siriusTuner.channels[ch] != null && siriusTuner.channels[ch].currentArtist != null && trim(siriusTuner.channels[ch].currentArtist) != "") {
		var currentArtist = trim(siriusTuner.channels[ch].currentArtist);
		addToAlert("% by: " + currentArtist);
	}	
}

function mnuAddTitleToAlertClicked(ch) {
	var siriusTuner = SiriusTuner.instance;
	if (siriusTuner.channels[ch] != null && siriusTuner.channels[ch].currentTitle != null && trim(siriusTuner.channels[ch].currentTitle) != "") {
		var currentTitle = trim(siriusTuner.channels[ch].currentTitle);
		var currentArtist = trim(siriusTuner.channels[ch].currentArtist);
		addToAlert(currentTitle + " by: " + currentArtist);
	}
}

function addToAlert(str) {
	var item5 = preferences.alertItem5.value;
	item5 = (item5 == null || trim(item5 == "") ? "" : item5 + "::") + str;
	preferences.alertItem5.value = item5;
}

function mnuLoginClicked() {
	// grab the main Sirius tuner object and Player object		
	var siriusTuner = SiriusTuner.instance;
	var player = Player.instance;

	siriusTuner.cookies = null;
	siriusTuner.cookieCount = 0;
	siriusTuner.channels = null;
	siriusTuner.channelPlaying = null;
	siriusTuner.firstChannel = null;
	siriusTuner.currentChannel = null;
	siriusTuner.lastChannel = null;

	// check for user/pass from preferences
	if (preferences.user.value != null && preferences.user.value != "") {
		if (preferences.password.value != null && preferences.password.value != "") {
			// username and password are available, start the login
			siriusTuner.user = preferences.user.value;
			siriusTuner.password = preferences.password.value;
			player.login();
		} else {
			// username available, but no password
			player.mainScreen.setStatusDisplay("Please enter your password in the preferences");
			showWidgetPreferences();
		}
	} else {
		// username and password not available
		player.mainScreen.setStatusDisplay("Please enter your username and password in the preferences");
		showWidgetPreferences();
	}

	if (siriusTuner.isLoggedIn()) {
		// start playing the last channel played
		log("Trying setSelectedChannel (mnuLoginClicked): " + preferences.lastChannel.value);
		if (preferences.lastChannel.value != null && preferences.lastChannel.value > 0) {
			player.setSelectedChannel(preferences.lastChannel.value);
			if (preferences.autoPlayAtStartup.value == 1)
				player.playChannel(preferences.lastChannel.value);
		} else {
			player.showGuide();
		}
	}
}

function mnuUseSiriusBackstageDataClicked() {
	preferences.useSiriusBackstageData.value = (preferences.useSiriusBackstageData.value * -1) + 1; //logical not

	if (preferences.useSiriusBackstageData.value == 1) {
		player.siriusTuner.loadWhatsOn();
	} else {
		player.siriusTuner.firstChannel.resetData();
		player.updateScreen();
	}
	player.updateNumberButtonTooltips();
	if (player.activeScreen instanceof ChannelGuideScreen)
		player.activeScreen.updateChannelData();
	player.refreshWhatsOnTimer.ticking = (preferences.useSiriusBackstageData.value == 1);
}

function mnuUseArtistAlertClicked() {
	preferences.alertEnable.value = (preferences.alertEnable.value * -1) + 1; //logical not
}

function mnuUseAlarmClockClicked() {
	preferences.enableAlarm.value = (preferences.enableAlarm.value * -1) + 1; //logical not
	Player.instance.mainScreen.alarmIcon.opacity = 40 + (preferences.enableAlarm.value * 215); //40 or 255 depending whether or not alarm is enabled
	this.alarm.ticking = (preferences.enableAlarm.value == 1);
}

function decodeEntities(str) {
	var startPos = str.indexOf("&");
	while (startPos > -1) {
		endPos = str.indexOf(";", startPos);
		if (endPos > -1) {
			var replacement = "";
			if (str.charAt(startPos + 1) == "#") {
				replacement = String.fromCharCode(str.substring(startPos + 2, endPos));
			} else {
				var entity = str.substr(startPos + 1, endPos - (startPos + 1));
				switch (entity) {
					case "quot": replacement = "\""; break;
					case "amp": replacement = "&"; break;
					case "lt": replacement = "<"; break;
					case "gt": replacement = ">"; break;
					case "apos": replacement = "'"; break;
				}
			}
			str = str.replace(str.substring(startPos, endPos + 1), replacement);
		}
		startPos = str.indexOf("&", startPos + 1);
	}
	return str;
}

function checkForUpdate(alertOnFalse) {
	this.checkForUpdates.interval = (preferences.updatesInterval.value * 3600);
	this.checkForUpdates.ticking = (preferences.updatesEnableAlert.value == 1);
	var verChk = new VersionChecker("38478", "SIRIUS Satellite Tuner", widget.version, alertOnFalse);
	verChk.checkVersion();
}

function ltrim(str) {
	try {
  	return str.replace(/^[ ]+/, "");
  } catch (e) {
  	return str;
  }
}

function rtrim(str) {
	try {
  	return str.replace(/[ ]+$/, "");
  } catch (e) {
  	return str;
  }
}

function trim(str) {
    return ltrim(rtrim(str));
}

function endsWith(str, val) {
	return str.lastIndexOf(val) == (str.length - val.length);
}

function beginsWith(str, val) {
	return str.indexOf(val) == 0;
}

function padLeft(str, totalWidth, paddingChar) {
	if (paddingChar == null) paddingChar = " ";

	if (str.length < totalWidth) {
		var dif = totalWidth - str.length;
		for (var i = 0; i < dif; i++) {
			str = paddingChar + str;
		}
	}
	return str;
}

function padRight(str, totalWidth, paddingChar) {
	if (paddingChar == null) paddingChar = " ";

	if (str.length < totalWidth) {
		var dif = totalWidth - str.length;
		for (var i = 0; i < dif; i++) {
			str += paddingChar;
		}
	}
	return str;
}

function setMessengerStatus(ch) {
	if (system.platform != "windows") return;
	var cmd = "resources/programs/isc.exe";
	var currentArtist = ch.currentArtist;
	var currentTitle = ch.currentTitle;

	if (currentArtist == null || currentArtist == undefined || trim(currentArtist).length == 0 || currentArtist == "undefined") {
		if (ch.name == null || ch.name == undefined || trim(ch.name).length == 0 || ch.name == "undefined") {
			currentArtist = "SIRIUS " + ch.num;
		} else {
			currentArtist = ch.name;
		}
	}

	if (currentTitle == null || currentTitle == undefined || trim(currentTitle).length == 0 || currentTitle == "undefined")
		currentTitle = "Waiting for data...";
	if (preferences.setYahooStatus.value == 1)
		cmd += " \"yah:" + currentArtist + " - " + currentTitle + "\"";
	if (preferences.setMSNStatus.value == 1)
		cmd += " \"msn:" + currentArtist + "::::" + currentTitle + "\"";
	if (preferences.setAIMStatus.value == 1)
		cmd += " \"aim:" + currentArtist + " - " + currentTitle + "\"";

	if (cmd != "resources/programs/isc.exe")
		runCommand(cmd);
}

function isEmailAddress(str) {
	var pattern = /^[A-Za-z0-9._%-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,4}$/;
	var matches = pattern.exec(str);
	return (matches != null);
}

function ExtractBetween(searchString, endString, searchIn, fromEnd) {
	var resp = searchIn;
	
	if (fromEnd == true) {
		var startIndex = resp.lastIndexOf(searchString);	
	} else { var startIndex = resp.indexOf(searchString); }
	
	if (startIndex > -1)
		startIndex += searchString.length;
	else
		return null;

	var length = resp.indexOf(endString, startIndex);
	if (length > -1)
		length -= startIndex;
	else
		length = resp.length - startIndex;

	var ret = resp.substring(startIndex, startIndex + length);
	return ret;
}

function like(needle, haystack) { //needle uses sql style wildcards (%).. if x = y return true otherwise return false
	needle = trim(needle);
	haystack = trim(haystack);
	if (needle.indexOf("%") == -1) {
		return (needle.toLowerCase() == haystack.toLowerCase());
	} else if (trim(needle) == "%") {
		return true;
	}
		
	arr = needle.split("%")
	if (arr.length > 1) {
		if (arr[0] == "" && arr[arr.length-1] == "") { //ex: needle = "%Hot Chili%"... matches "Red Hot Chili Peppers" and "Hot Chili Peppers" and "Red Hot Chili"
			return (haystack.toLowerCase().indexOf(arr.join("").toLowerCase()) > -1);
		} else if (arr[0] == "" && (haystack.toLowerCase().indexOf(arr.join("").toLowerCase()) > -1)) { //ex: needle = "%Hot Chili"... matches "Red Hot Chili", but not "Red Hot Chili Peppers" or "Hot Chili Peppers"
			return (haystack.toLowerCase().indexOf(arr.join("").toLowerCase()) == (haystack.length - arr.join("").length));
		} else if (arr[arr.length-1] == "") { //ex: needle = "Hot Chili%"... matches "Hot Chili Peppers", but not "Red Hot Chili Peppers" or "Red Hot Chili"
			return (haystack.toLowerCase().indexOf(arr.join("").toLowerCase()) == 0);
		}
	}
}

function onTellWidget(str) {
	log("onTellWidget: " + str);
	var cmd = str.split("?")[0];
	var params = str.split("?")[1].split("|");
	switch (cmd) {
		case "loadSkin": dropSkin(params[0]); break;
		case "playChannel": Player.instance.playChannel(params[0]); break;
		case "stop": Player.instance.stop(); break;
		case "play": Player.instance.play(); break;
		case "nextChannel": Player.instance.nextChannel(); break;
		case "prevChannel": Player.instance.previousChannel(); break;
		case "setVolume":
			if (params[0].substring(0, 1) == "+") { SiriusTuner.instance.setVolume(SiriusTuner.instance.getVolume() + parseInt(params[0].substring(1), 10)); break; }
			if (params[0].substring(0, 1) == "-") { SiriusTuner.instance.setVolume(SiriusTuner.instance.getVolume() - parseInt(params[0].substring(1), 10)); break; }
			SiriusTuner.instance.setVolume(parseInt(params[0], 10)); break;
		case "mute": SiriusTuner.instance.mute(); break;
		case "pngout": pngout(params[0]); break;
		case "takeScreenShot": takeScreenShot(); break;
	}
}

/**
	Compares two version numbers, ex: 3.1 < 3.1.1; 3.1.0 > 3.1; 4.200.89 > 4.20.8
	a < b = -1; a > b = 1; a = b = 0
 */
function compareVersionNum(a, b) {
	if (a == b) return 0;
	var aver = a.split(".");
	var bver = b.split(".");
	
	for (var i = 0; i < aver.length + ((aver.length - bver.length) * -1); i++) {
		if (aver[i] - bver[i] < 0 || (aver[i] == null && bver[i] >= 0)) return -1;
		if (aver[i] - bver[i] > 0) return 1;
	}
	return 1;
}

function HighBitrateEnabled(resp) {
	var imgIndex = resp.indexOf("hi-reg.gif");
	var searchString = "href=\"";
	var endString = "\"";
	if (imgIndex > -1) {
		var startIndex = resp.lastIndexOf(searchString, imgIndex);
		
		if (startIndex > -1)
			startIndex += searchString.length;
		else
			return null;

		var length = resp.indexOf(endString, startIndex);
		if (length > -1)
			length -= startIndex;
		else
			length = resp.length - startIndex;
	
		var ret = resp.substring(startIndex, startIndex + length);
		return (ret != "#");
	} else {
		return null;
	}
}

function stringToBoolean(str) {
	str = trim(String(str).toLowerCase());
	if (str == "0" || str == "false" || str == "no" || str == "off" || str == "lo" || str == "low" || trim(str) == "")
		return false;
	return true;
}

function checkInitialLoad() {
	if (preferences.lastRunVersion.value != widget.version) {
		log("Initial load returned true, resetting initial load dependent defaults...");
		deleteDefaultSkin();
		resetCachedLogin();
		preferences.lastRunVersion.value = widget.version;
		savePreferences();
	}
}

function resetCachedLogin() {
	for (var i in preferences) {
		if (i.substring(0, 6) == "cookie") {
			preferences[i].value = null;
		}
	}
	preferences.token.value = null;
}

function setWhatsOnDataSource() {
	SiriusTuner.instance.getWhatsOnSources();
	formFields = new Array();
	formFields[0] = new FormField();
	formFields[0].name = "url";
	formFields[0].title = "Data Source:";
	formFields[0].type = "popup";
	formFields[0].option = new Array();
	formFields[0].optionValue = new Array();

	var count = 0;
	for (i = 0; i <= urls.length - 1; i++) {
		formFields[0].option[count] = urls[i];
		formFields[0].optionValue[count] = urls[i];
		count++;
	}
	formFields[0].value = preferences.whatsOnDataURL.value;
	
	formResults = form(formFields, "Select a What's On Data Source", "OK");
	
	if (formResults != null) {
		preferences.whatsOnDataURL.value = formResults[0];
	}
}

function zoomWidget(factor, svs, iteration) {
	log(svs.length);
	for (var i = 0; i < svs.length; i++) {
		log(i + ": " + String(svs[i]));
		if (String(svs[i]) == "[object Image]" || String(svs[i]) == "[object Text]") {
			svs[i].width *= factor;
			svs[i].height *= factor;
			svs[i].hOffset *= factor;
			svs[i].vOffset *= factor;
			if (String(svs[i]) == "[object Text]")
				svs[i].size *= factor;
		} else if (String(svs[i]) == "[object Frame]") {
			zoomWidget(factor, svs[i].subviews, iteration + 1);
		}
	}
	
	if (iteration == 1) {
		main.width *= factor
		main.height *= factor
		main.hOffset -= (main.width / factor)
		main.vOffset -= (main.height / factor)
	}
}

function getWidgetPath() {
	var ret = null;
	if (system.platform == "windows") {
		try {
			var vals = regGetValue("HKEY_CURRENT_USER\\Software\\Yahoo\\WidgetEngine\\LoadedWidgets");
			if (vals != null) {
				if (vals.length > 0) {
					for (var i = 0; i < vals.length; i++) {
						if (endsWith(vals[i].toLowerCase(), ".widget")) {
							var f = vals[i].split("\\");
							if (f[f.length-1].toLowerCase().indexOf("sirius") > -1) {
								if (ret == null) {
									ret = vals[i];
								} else {
									return null;
								}
							}
						}
					}		
				}
			}
		} catch(e) {
			log("getWidgetPath(Widget.js): Failed due to " + e);	
		}
	}
	return ret;
}

function updateParentalControls() {
	var oldEnabled = preferences.enableParentalControls.value;
	var newEnabled = preferences.enableParentalControls1.value;
	var oldPassword = preferences.parentalPassword.value;
	var newPassword = preferences.parentalPassword1.value;
	var oldChannels = preferences.blockedChannels.value;
	var newChannels = preferences.blockedChannels1.value.replace(/\s*,\s*/g, ",").replace(/^,+/g, "").replace(/,+$/g, "");
	var newChannelsArray = newChannels.split(",")
	newChannelsArray.sort();
	newChannels = newChannelsArray.join(",")
	
	if ((newEnabled != oldEnabled) || (newPassword != oldPassword) || (newChannels != oldChannels)) {
		if (prompt("Parental Controls", "Current Password:", true) == oldPassword) {
			preferences.enableParentalControls.value = newEnabled;
			preferences.parentalPassword.value = newPassword;
			preferences.blockedChannels.value = newChannels;
			savePreferences();
			
			if (SiriusTuner.instance.currentChannel != null) {
				if (SiriusTuner.instance.currentChannel.isBlocked()) {
					SiriusTuner.instance.stop();					
				}
			}
		} else {
			alert("The parental controls password you entered is incorrent. If you are setting up the password for the first time, the current password is left blank. Please try again.");
		}
	}
}

function prompt(title, label, secure) {
	var formFields = new Array();
	formFields[0] = new FormField();
	formFields[0].name = "password";
	formFields[0].title = label;
	formFields[0].type = "text";
	formFields[0].secure = (secure == null ? false : secure);

	var formResults = form(formFields, title, "OK");

	if (formResults != null) {
		return formResults[0];
	}
	return null;
}

function importPreferences() {
	var path = chooseFile(".swp");
	try {
		eval(filesystem.readFile(path));
		savePreferences();
		reloadWidget();
	} catch (e) {
		alert("Import Preferences Failed: " + e);
	}
}

function exportPreferences() {
	var path = chooseFile(".swp");
	var myData = new Array();
	
	for (var p in preferences) {
		var pref = eval("preferences." + p);
		if (!pref.notSaved) {
			if (pref.secure) {
				if (prompt("Sirius Satellite Tuner", pref.description, true) != pref.value) {
					alert("The password you entered was not correct. This preference will not be saved.");
					continue;
				}
			}
			var val = getPreferenceValue(pref);
			myData[myData.length] = "preferences." + p + ".value = " + val + ";";
		}
	}
	filesystem.writeFile(path, myData);
}

function getPreferenceValue(pref) {
	val = pref.value;
	switch (pref.type) {
		case 100: //string
		case 101:
		case 107:
			return "\"" + val + "\"";
			break;
		case 102: //number
		case 103:
			if (val == "") val = 0;
			return val;
			break;
	}
}